/*************************************************************************
 *
 *    Used with ICCARM and AARM.
 *
 *    (c) Copyright IAR Systems 2007
 *
 *    File name   : usb_cnfg.h
 *    Description : USB config file
 *
 *    History :
 *    1. Date        : June 16, 2007
 *       Author      : Stanimir Bonev
 *       Description : Create
 *
 *    $Revision: 1.3 $
 **************************************************************************/

#include <includes.h>

#ifndef __USB_CNFG_H
#define __USB_CNFG_H

// Enable/Disable trace info
#define USB_TRACE_LM_EN           0
#define USB_TRACE_LW_EN           0
#define USB_TRACE_LE_EN           0
#define USB_TRACE_T9M_EN          0
#define USB_TRACE_T9W_EN          0
#define USB_TRACE_T9E_EN          0

/* USB interrupt priority */
#define USB_INTR_LOW_PRIORITY     1
#define USB_INTR_HIGH_PRIORITY    0

#define USB_DEV_HIGH_PRIORITY     0x00
#define USB_EP_HIGH_PRIORITY      0x0000

/* DMA transfer */
#define USB_DMA                   0
#define USB_INTR_DMA0_PRIORITY    0
#define USB_INTR_DMA1_PRIORITY    0

/* USB Events */
#define USB_SOF_EVENT             0
#define USB_PSOF_EVENT            0
#define USB_SUSPEND_EVENT         1
#define USB_DMA_EVENT             (USB_DMA != 0)

/* USB High speed support */
#define USB_HIGH_SPEED            1

/* Max Interfaces number*/
#define USB_MAX_INTERFACE         1

/* Endpoint definitions */
#define Ep0MaxSize                64
#define ReportEp                  ENP1_IN
#define ReportEpMaxSize           3

/* Device power atrb  */
#define USB_SELF_POWERED          1
#define USB_REMOTE_WAKEUP         0

/* Class defenitions*/
#define HID_BOOT_DEVICE           0
#define HID_INTERFACE_0           0

/* Other defenitions */

#endif //__USB_CNFG_H
